//  Buildings
//  mainbld3.inc
//  February, 1999
//  Robert J Becraft
//
#ifndef(RoofText101)
  #declare RoofText101=texture{pigment{color Orange}}
#end
#ifndef(BrickText101)
  #declare BrickText101=texture{pigment{brick Gray10,Tan brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText102)
  #declare BrickText102=texture{pigment{brick Gray10,Gray brick_size <.75,.35,.35> mortar .02}}
#end
#ifndef(BrickText103)
  #declare BrickText103=texture{pigment{brick Gray10,White brick_size <1.,.15,.15> mortar .02}}
#end
#ifndef(BrickText104)
  #declare BrickText104=texture{pigment{brick Gray10,Brown brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText105)
  #declare BrickText105=texture{pigment{brick Gray10,Wheat brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText106)
  #declare BrickText106=texture{pigment{brick Gray10,Gray50 brick_size <.75,.35,.35> mortar .02}}
#end
#ifndef(BlackText)
  #declare BlackText=texture{pigment{color Black}}
#end
#ifndef(WoodSide101)
  #declare WoodSide101=texture{
       gradient x
       texture_map{
         [0.0 T_Wood18]
         [0.995 BlackText]
       }
       scale .5
}
#end


// Buildings ----------------------------------------------------
#declare Door301=union{
     box{<-.5,0,-.5><.5,.25,.5> texture{StoneWalk}}
     box{<-.5,0,-.04><-.48,2,.04> texture{pigment{color White}}}
     box{<.48,0,-.04><.5,2,.04> texture{pigment{color White}}}
     box{<-.5,2,-.04><.5,2.1,.04> texture{pigment{color White}}}
     box{<-.45,0,-.02><.45,2,.02> texture{pigment{color Tan}}}
}
#declare Shutter=union{
     box{<-.13,0,-.02><-.11,1.5,.02> texture{Shutter_Color}}
     box{<.11,0,-.02><.13,1.5,.02> texture{Shutter_Color}}
     box{<-.109,0,-.02><.109,.03,.02> texture{Shutter_Color}}
     box{<-.109,1.47,-.02><.109,1.5,.02> texture{Shutter_Color}}
     box{<-.1095,.72,-.02><.1095,.78,.02> texture{Shutter_Color}}
     #declare Count=1.40
     #while (Count>.76)
            box{<-.11,0,-.02><.11,.04,.02> texture{Shutter_Color} rotate<-25,0,0> translate<0,Count,0>}
            box{<-.11,0,-.02><.11,.04,.02> texture{Shutter_Color} rotate<-25,0,0> translate<0,Count-.75,0>}
            #declare Count=Count-.06
     #end
}
#declare Shutter301=union{
     object{Shutter translate<-.52,0,0>}
     object{Shutter translate<.52,0,0>}
}
#declare Clothesline=union{
     cone{<-2,0,-2>,.03 <-2.25,2,-2.25>,.03 texture{pigment{color Tan}}}
     cone{<2,0,2>,.03 <2.75,2,2.75>,.03 texture{pigment{color Tan}}}
     cone{<-2.25,1.9,-2.25>.01<2.75,1.9,2.75>,.01 texture{pigment{color White}}}
}
#declare Clothes=union{
    object{Clothesline}

//  clothes shapes....
     triangle{<-2.25,1.9,-2.25> <-1,1.9,-1> <-2,.3,-1.5> texture{pigment{color Wheat}}}
     triangle{<-2.25,1.9,-2.25><-3,.3,-2.5> <-2,1.6,-1> texture{pigment{color Wheat}}}

     triangle{<0,1.9,0><.5,1.9,.5><.5,.6,.5> texture{pigment{color Orange}}}
     triangle{<0,1.9,0><.51,.6,.51> <0,.2,.2> texture{pigment{color Orange}}}

     triangle{<1,1.9,1><1.5,1.9,1.5><1.5,.6,1.5> texture{pigment{color Blue}}}
     triangle{<1,1.9,1><1.51,.6,1.51> <1,.2,1.2> texture{pigment{color Blue}}}

     triangle{<1.75,1.9,1.75><2.25,1.9,2.25><2.25,.6,2.25> texture{pigment{color Green}}}
     triangle{<1.75,1.9,1.75><2.25,1.9,2.25><1.75,.3,1.75> texture{pigment{color Green}}}
}

#declare Clothes2=union{
    object{Clothesline}
     triangle{<1,1.9,1><1.5,1.9,1.5><1.5,.6,1.5> texture{pigment{color Yellow}}}
     triangle{<1,1.9,1><1.51,.6,1.51> <1,.2,1.2> texture{pigment{color Yellow}}}

     triangle{<1.75,1.9,1.75><2.25,1.9,2.25><2.25,.6,2.25> texture{pigment{color Blue}}}
     triangle{<1.75,1.9,1.75><2.25,1.9,2.25><1.75,.3,1.75> texture{pigment{color White}}}
}


//----------- Minuret Definitions -----------------------
#declare Minuret=union{
     difference{
        sphere{<0,0,0>1.5 texture{RoofText}}
        torus{1.7,.8 translate<0,1.3,0> texture{RoofText}}
      }
     cone{<0,3.5,0>.12 <0,5.7,0>,0 texture{RoofText}}
     cone{<0,1.65,0>.55 <0,3.5,0>,.12 texture{RoofText}}
     cone{<0,0,0>1.2 <0,1.65,0>,.55 texture{RoofText}}

    difference{
        union{
           cone{<0,-10,0>1.5 <0,0,0>1 texture{White_Stone}}
           box{<-1,-3.7,-.4><1,-1.3,.4> texture{TileWork}}
           box{<-1,-3.7,-.4><1,-1.3,.4> texture{TileWork} rotate<0,45,0>}
           box{<-1,-3.7,-.4><1,-1.3,.4> texture{TileWork} rotate<0,-45,0>}
        }
       box{<-1.1,-3.5,-.2><1.1,-1.5,.2> texture{White_Stone}}
       box{<-1.1,-3.5,-.2><1.1,-1.5,.2> texture{White_Stone} rotate<0,45,0>}
       box{<-1.1,-3.5,-.2><1.1,-1.5,.2> texture{White_Stone} rotate<0,-45,0>}
    }
    cylinder{<0,-1.2,0><0,-1,0>1.1 texture{TileWork}}
    cylinder{<0,-10,0><0,-7,0> 1.6 texture{White_Stone}}
    cylinder{<0,-7,0><0,-6.99,0> 1.6 texture{pigment{checker White,Black} scale .2}}
}

//------------- OBELISK Defs
#declare Obelisk_Side=union{
     triangle{<-.75,30,-.75><0,33,0><.75,30,-.75> texture{pigment{color White}}}
     triangle{<-2,0,-2><-.75,30,-.75><.75,30,-.75> texture{pigment{color White}}}
     triangle{<-2,0,-2><.75,30,-.75><2,0,-2> texture{pigment{color White}}}
     box{<-2.2,0,-2.2><2.2,0,-2> texture{White_Stone}}
}
#declare Obelisk=union{
     object{Obelisk_Side}
     object{Obelisk_Side rotate<0,90,0>}
     object{Obelisk_Side rotate<0,-90,0>}
     object{Obelisk_Side rotate<0,180,0>}
}


#declare House301=union{
         difference{
             box{<-5,0,-5><0,6,0> texture{White_Stucco}}
             box{<-4.7,5.8,-4.7><-.3,6.1,-.3> texture{StoneWalk}}
             box{<-4,3,-5.1><-3.5,4.5,.1> texture{StoneWalk}}
             box{<-2,3,-5.1><-1.5,4.5,.1> texture{StoneWalk}}
          }
          difference{
             box{<0,0,-3><3,6.5,5> texture{White_Stucco}}
             box{<.3,6.2,-2.7><2.7,6.6,4.7> texture{StoneWalk}}
             box{<1.5,3,-3.1><2.25,4.5,5.1> texture{StoneWalk}}
          }
          box{<-4,0,0><-2,8,5> texture{White_Stucco}}
          box{<-3.8,8,.2><-2.2,8.2,4.8> texture{StoneWalk}}

          box{<0,0,-5.1><5,2,-4.8> texture{White_Stucco}}   // garden
          box{<4.8,0,-5><5.1,2,-1> texture{White_Stucco}}
          box{<4.7,0,-1.3><5.2,3,-1> texture{StoneWalk}}

         object{Shutter301 translate<-3.75,3,-5.05> }
         object{Shutter301 translate<-1.75,3,-5.05>}

         object{Door301 translate<2,0,-3>}
         object{Door301 translate<-3,0,-5>}
         object{Door301 translate<-2,0,5>}
}

#declare House302=union{
         difference{
             box{<-5,0,-5><0,6,0> texture{White_Stucco}}
             box{<-4.7,5.8,-4.7><-.3,6.1,-.3> texture{StoneWalk}}
             box{<-4,3,-5.1><-3.25,4.5,.1> texture{StoneWalk}}
             box{<-2,3,-5.1><-1.25,4.5,.1> texture{StoneWalk}}
             translate<0,0,1>
          }
          difference{
             box{<0,0,-3><3,6.5,5> texture{White_Stucco}}
             box{<.3,6.2,-2.7><2.7,6.6,4.7> texture{StoneWalk}}
             box{<1.5,3,-3.1><2.25,4.5,5.1> texture{StoneWalk}}
          }
          box{<-4,0,0><-2,8,5> texture{White_Stucco} translate<1,0,0>}

         object{Door301 translate<2,0,-3>}
         object{Door301 translate<-3,0,-4>}
         object{Door301 translate<-2,0,5>}
}

#declare House303=union{
         difference{
             box{<-5,0,-5><0,6,0> texture{White_Stucco}}
             box{<-4.7,5.8,-4.7><-.3,6.1,-.3> texture{StoneWalk}}
             box{<-4,3,-5.1><-3.5,4.5,.1> texture{StoneWalk}}
             box{<-2,3,-5.1><-1.5,4.5,.1> texture{StoneWalk}}
          }
          difference{
             box{<0,0,-3><5,6.5,5> texture{White_Stucco}}
             box{<.3,6.2,-2.7><4.7,6.6,4.7> texture{StoneWalk}}
             box{<1.5,3,-3.1><2.25,4.5,5.1> texture{StoneWalk}}
          }

          box{<2,0,-3><4,7,-5> texture{White_Stucco}}
          box{<1.95,7,-3.05><4.05,7.2,-5.05> texture{StoneWalk}}

          difference{
             box{<-3,5.8,-3><1,7,2> texture{White_Stucco}}
             box{<-2.7,6.8,-2.7><.7,7.1,1.7> texture{StoneWalk}}
          }

         object{Shutter301 translate<-3.75,3,-5.05> }
         object{Shutter301 translate<-1.75,3,-5.05>}

         object{Door301 translate<3,0,-5>}
         object{Door301 translate<-3,0,-4>}
         object{Door301 translate<-2,0,5>}
}

#declare House304=union{
         difference{
             box{<-5,0,-5><0,6,0> texture{Tan_Stucco}}
             box{<-4.7,5.8,-4.7><-.3,6.1,-.3> texture{StoneWalk}}
             box{<-4,3,-5.1><-3.5,4.5,.1> texture{StoneWalk}}
             box{<-2,3,-5.1><-1.5,4.5,.1> texture{StoneWalk}}
          }
          difference{
             box{<0,0,-3><5,6.5,5> texture{Tan_Stucco}}
             box{<.3,6.2,-2.7><4.7,6.6,4.7> texture{StoneWalk}}
             box{<1.5,3,-3.1><2.25,4.5,5.1> texture{StoneWalk}}
          }

          box{<2,0,-3><4,7,-5> texture{Tan_Stucco}}
          box{<1.95,7,-3.05><4.05,7.2,-5.05> texture{StoneWalk}}

          difference{
             box{<-3,5.8,-3><1,7,2> texture{Tan_Stucco}}
             box{<-2.7,6.8,-2.7><.7,7.1,1.7> texture{StoneWalk}}
          }

         object{Shutter301 translate<-3.75,3,-5.05> }
         object{Shutter301 translate<-1.75,3,-5.05>}

         object{Door301 translate<3,0,-5>}
         object{Door301 translate<-3,0,-4>}
         object{Door301 translate<-2,0,5>}
}

#declare House305=union{
        box{<-5,0,-5><-2,6,5> texture{Tan_Stucco}}
        box{<2,0,-5><5,6,5> texture{Tan_Stucco}}
        box{<-2,0,-2><2,6,2> texture{Tan_Stucco}}
        box{<0,0,2><2,7.5,2> texture{Tan_Stucco}}

        box{<-5,6,-5><-2,6.1,5> texture{StoneWalk}}
        box{<2,6,-5><5,6.1,5> texture{StoneWalk}}
        box{<-2,6,-2><2,6.1,2> texture{StoneWalk}}
        box{<0,7.5,2><2,7.6,2> texture{StoneWalk}}

        box{<-5.1,6.1,-5.1><-1.9,6.2,5.1> texture{StoneWalk}}
        box{<2.1,6.1,-5.1><5.1,6.2,5.1> texture{StoneWalk}}
        box{<-2.1,6.1,-2.1><2.1,6.2,2.1> texture{StoneWalk}}

        box{<3,6.2,3><3.75,7,3.75> texture{White_Stucco}}
        cylinder{<3.375,7,3.375><3.375,8,3.375>,.25 texture{pigment{color Gray30}}}

        object{Door301 translate<4,0,-5>}
         object{Door301 translate<-4,0,-5>}
}
#declare House306=union{
         object{House305}
        object{Clothes translate<-3,6.1,-3>}
        object{Clothes2 rotate<0,90,0>translate<3,6.1,-3>}
}
