//  Buildings
//  mainbldg.inc
//  August, 1998
//  Robert J Becraft
//
#ifndef(RoofText101)
  #declare RoofText101=texture{pigment{color Orange}}
#end
#ifndef(BrickText101)
  #declare BrickText101=texture{pigment{brick Gray10,Tan brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText102)
  #declare BrickText102=texture{pigment{brick Gray10,Gray brick_size <.75,.35,.35> mortar .02}}
#end
#ifndef(BrickText103)
  #declare BrickText103=texture{pigment{brick Gray10,White brick_size <1.,.15,.15> mortar .02}}
#end
#ifndef(BrickText104)
  #declare BrickText104=texture{pigment{brick Gray10,Brown brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText105)
  #declare BrickText105=texture{pigment{brick Gray10,Wheat brick_size <.25,.10,.10> mortar .01}}
#end
#ifndef(BrickText106)
  #declare BrickText106=texture{pigment{brick Gray10,Gray50 brick_size <.75,.35,.35> mortar .02}}
#end
#ifndef(BlackText)
  #declare BlackText=texture{pigment{color Black}}
#end
#ifndef(WoodSide101)
  #declare WoodSide101=texture{
       gradient x
       texture_map{
         [0.0 T_Wood18]
         [0.995 BlackText]
       }
       scale .5
}
#end


// Buildings ----------------------------------------------------
#declare Build1=union{
    box{<-5,0,-4><5,8,4> texture{BrickText101}}
    box{<-5.2,7,-4.2><5.2,7.3,4.2> texture{BrickText104}}
    box{<-5.2,7.5,-4.2><5.2,8,4.2> texture{BrickText101}}
    box{<-5,8,-4><5,8.5,-3.95> texture{BrickText101}}
    box{<-5,8,4><5,8.5,3.95> texture{BrickText101}}
    box{<-5,8,-4><-4.95,8.5,4> texture{BrickText101}}
    box{<4.95,8,-2><5,8.5,4> texture{BrickText101}}
    box{<-1.5,8,-1.5><1.5,8.2,1.7> texture{BrickText102}}
    box{<-4,8,-4><-3,12,-3> texture{BrickText101}}
    object{Door1 translate<-5,0,0>}
    object{Window1 translate<-5,.4,-3>}
    object{Window1 translate<-5,.4,3>}
    object{Window1 translate<-5,3.7,-3>}
    object{Window1 translate<-5,3.7,3>}
    object{Window1 translate<-5,3.7,0>}

    object{Window1 rotate<0,90,0> translate<-3,.4,-4>}
    object{Window1 rotate<0,90,0> translate<-3,3.7,-4>}
    object{Window1 rotate<0,90,0> translate<3,3.7,-4>}

}

#declare Build2=union{
    box{<-4,0,-4><4,4,4> texture{pigment{color Gray50}}}
    box{<-4.2,3.8,-4.2><4.2,4,4.2> texture{BrickText103}}
    triangle{<-4,4,-4><-4,4,4><0,8,0> texture{RoofText101}}
    triangle{<-4,4,-4><4,4,-4><0,8,0> texture{RoofText101}}
    triangle{<4,4,-4><4,4,4><0,8,0> texture{RoofText101}}
    triangle{<-4,4,4><4,4,4><0,8,0> texture{RoofText101}}
    box{<-3,4,-3><-2,8,-2> texture{BrickText101}}
    object{Door1 translate<-4,.2,0>}
    object{Door1 rotate<0,90,0> translate<2,.4,-4>}
    object{Window1 rotate<0,90,0> translate<-2,.4,-4>}
    object{Window1 rotate<0,90,0> translate<0,.4,-4>}
}

#declare Build3=union{
    box{<-6,0,-4><6,4,4> texture{pigment{color Gray50}}}
    object{Door1 translate<-6,.2,0>}
    object{Door1 rotate<0,90,0> translate<2,.2,-4>}
    object{Window1 rotate<0,90,0> translate<-2,.4,-4>}
    object{Window1 rotate<0,90,0> translate<0,.4,-4>}
    object{Window1 rotate<0,90,0> translate<-2,.4,4>}
    object{Window1 rotate<0,90,0> translate<0,.4,4>}

    triangle{<-6.2,4,-4.2><-6.2,4,4.2><0,10,0> texture{RoofText101}}
    triangle{<-6.2,4,-4.2><6.2,4,-4.2><0,10,0> texture{RoofText101}}
    triangle{<6.2,4,-4.2><6.2,4,4.2><0,10,0> texture{RoofText101}}
    triangle{<-6.2,4,4.2><6.2,4,4.2><0,10,0> texture{RoofText101}}

    cylinder{<4,0,3><4,10,3>,2 texture{pigment{color Gray20}}}
    cone{<4,10,3>2.2<4,17,3>,0 texture{RoofText101}}
    #declare Count=0
    #while (Count<360)
       object{Window1 rotate<0,0,0> translate<2,0,0> rotate<0,Count,0> translate<4,7.5,3>}
       #declare Count=Count+90
    #end
}

#declare Build4=union{   // well
    difference{
         cylinder{<0,0,0><0,1,0>,1.5 texture{pigment{color Gray}}}
         cylinder{<0,0,0><0,1.1,0>,1.3 texture{pigment{color Gray}}}
   }
   #if(rand(R1)*4>3)
     object{Main_Oak translate<3,0,3>}
   #end
}

#declare Build5=union{
    box{<-6,0,-4><6,9,4> texture{BrickText105}}
    box{<-6.2,8.6,-4.2><6.2,9,4.2> texture{BrickText103}}
    triangle{<-6,9,-4><-6,9,4><0,17,0> texture{BrickText101}}
    triangle{<-6,9,-4><6,9,-4><0,17,0> texture{BrickText101}}
    triangle{<6,9,-4><6,9,4><0,17,0> texture{BrickText101}}
    triangle{<-6,9,4><6,9,4><0,17,0> texture{BrickText101}}

    box{<-2,10,-3.5><2,12,3.5> texture{BrickText103}}
    triangle{<-2.2,12,-3.5><0,15,-3.5><2.2,12,-3.5> texture{BrickText103}}
    triangle{<-2.2,12,3.5><0,15,3.5><2.2,12,3.5> texture{BrickText103}}
    triangle{<-2.2,12,-3.7><0,15,3.7><0,15,-3.7> texture{BrickText101}}
    triangle{<-2.2,12,-3.7><0,15,3.7><-2.2,12,3.7> texture{BrickText101}}
    triangle{<2.2,12,-3.7><0,15,3.7><0,15,-3.7> texture{BrickText101}}
    triangle{<2.2,12,-3.7><0,15,3.7><2.2,12,3.7> texture{BrickText101}}
    object{Window1 rotate<0,90,0> translate<-1.2,10,-3.5>}
    object{Window1 rotate<0,90,0> translate<1.2,10,-3.5>}
    object{Window1 rotate<0,90,0> translate<0,10,-3.5>}
    object{Window1 rotate<0,90,0> translate<-1.2,10,3.5>}
    object{Window1 rotate<0,90,0> translate<1.2,10,3.5>}
    object{Window1 rotate<0,90,0> translate<0,10,3.5>}

    object{Door1 translate<-6,.2,0>}
    object{Door1 rotate<0,90,0> translate<2,.2,-4>}
    object{Window1 rotate<0,90,0> translate<-2,.3,-4>}
    object{Window1 rotate<0,90,0> translate<0,.3,-4>}
    object{Window1 rotate<0,90,0> translate<-2,.3,4>}
    object{Window1 rotate<0,90,0> translate<0,.3,4>}

     #declare FL=3.5
     #while (FL<9)
        #declare Count=-4
        #while (Count<=4)
             object{Window1 rotate<0,90,0> translate<Count,FL,-4>}
             object{Window1 rotate<0,90,0> translate<Count,FL,4>}
             #declare Count=Count+2.5
        #end
        #declare FL=FL+3
     #end
 }

#declare Build6=union{
    box{<-5,0,-5><5,9.3,5> texture{pigment{color Gray50}}}
    box{<-5.2,3,-5.2><5.3,3.2,5.3> texture{BrickText103}}
    box{<-5.2,6,-5.2><5.3,6.2,5.3> texture{BrickText103}}
    box{<-5.2,9,-5.2><5.3,9.2,5.3> texture{BrickText103}}
    box{<-5.3,0,-5.3><-5,9,-5> texture{BrickText105}}
    box{<-5.3,0,5.3><-5,9,5> texture{BrickText105}}
    box{<5.3,0,-5.3><5,9,-5> texture{BrickText105}}
    box{<5.3,0,5.3><5,9,5> texture{BrickText105}}

    object{Door1 translate<-5,.2,3>}
    object{Door1 rotate<0,90,0> translate<-2,.2,-5>}

    #declare Count=.2
    #while (Count<9)
      object{Window1 rotate<0,90,0> translate<-2,Count,-5>}
      object{Window1 rotate<0,90,0> translate<0,Count,-5>}
      object{Window1 rotate<0,90,0> translate<-2,Count,5>}
      object{Window1 rotate<0,90,0> translate<0,Count,5>}
      #declare Count=Count+3.5
    #end
}

#declare Build7=union{
     box{<-5,0,-5><-2,5,5> texture{BrickText102}}
     box{<5,0,-5><2,5,5> texture{BrickText102}}
     box{<-5.3,5,-5.3><5.3,8,5.3> texture{BrickText102}}
     box{<-5.4,8,-5.4><5.4,8.3,5.4> texture{BrickText103}}
     triangle{<-5.2,8.3,-5.2><5.2,8.3,-5.2><0,16.3,0> texture{RoofText101}}
     triangle{<-5.2,8.3,5.2><5.2,8.3,5.2><0,16.3,0> texture{RoofText101}}
     triangle{<-5.2,8.3,-5.2><-5.2,8.3,5.2><0,16.3,0> texture{RoofText101}}
     triangle{<5.2,8.3,-5.2><5.2,8.3,5.2><0,16.3,0> texture{RoofText101}}
     object{Door1 rotate<0,90,0> translate<-3.5,0,-5>}
     object{Door1 rotate<0,90,0> translate<4,0,-5>}
     #declare Count=-4.5
     #while (Count<=4.5)
             object{Window1 rotate<0,90,0> translate<Count,5.5,-5.4>}
             object{Window1 rotate<0,90,0> translate<Count,5.5,5.4>}
             object{Window1 rotate<0,0,0> translate<-5.4,5.5,Count>}
             object{Window1 rotate<0,0,0> translate<5.4,5.5,Count>}
             object{Window1 rotate<0,0,0> translate<-2.2,15.3,Count>}
             object{Window1 rotate<0,0,0> translate<2.2,15.3,Count>}
             #declare Count=Count+3
     #end

     box{<-2,8.3,-5.4><2,18,5.4> texture{BrickText102}}
     box{<-2.1,18,-5.5><2.1,18.2,5.5> texture{BrickText102}}
     box{<2,0,-3><2.8,26,-1> texture{BrickText101}}    // chimney
     triangle{<-2.2,18,-5.7><2.2,18,-5.7><0,26,0> texture{RoofText101}}
     triangle{<-2.2,18,5.7><2.2,18,5.7><0,26,0> texture{RoofText101}}
     triangle{<-2.2,18,-5.7><-2.2,18,5.7><0,26,0> texture{RoofText101}}
     triangle{<2.2,18,-5.7><2.2,18,5.7><0,26,0> texture{RoofText101}}
     #declare Count=8.3
     #while (Count<18)
             object{Window1 rotate<0,90,0> translate<-1,Count,-5.4>}
             object{Window1 rotate<0,90,0> translate<1,Count,-5.4>}
             object{Window1 rotate<0,90,0> translate<-1,Count,5.4>}
             object{Window1 rotate<0,90,0> translate<1,Count,5.4>}
             #declare Count=Count+3.5
     #end
}

#declare Build8=union{
     box{<-5,0,-3><5,10,5> texture{BrickText103}}
     box{<-5.2,10,-3.2><5.2,10.2,5.2> texture{BrickText105}}
     #declare Count=.5
     #while (Count <=9.5)
          box{<-5.1,Count,-3.1><-4.7,Count+.25,-2.7> texture{pigment{color Gray}}}
          box{<-5.1,Count,5.1><-4.7,Count+.25,4.7> texture{pigment{color Gray}}}
          box{<5.1,Count,-3.1><4.7,Count+.25,-2.7> texture{pigment{color Gray}}}
          box{<5.1,Count,5.1><4.7,Count+.25,4.7> texture{pigment{color Gray}}}
          #declare Count=Count+1
     #end
     object{Door1 translate<-5,.2,3>}
     object{Door1 rotate<0,90,0> translate<-2,.2,-3>}
     #declare FL=3.5
     #while (FL<9)
        #declare Count=-4
        #while (Count<=4)
             object{Window1 rotate<0,90,0> translate<Count,FL,-3>}
             object{Window1 rotate<0,90,0> translate<Count,FL,5>}
//             object{Window1 rotate<0,90,0> translate<-1,FL,5.4>}
//             object{Window1 rotate<0,90,0> translate<1,FL,5.4>}
             #declare Count=Count+3.5
        #end
        #declare FL=FL+3.5
     #end
}
#declare Build9=union{
     box{<-2,0,0><4,8,4> texture{BrickText101}}
     box{<-2.2,7.8,-.20><4.2,8,4.2> texture{BrickText103}}
     box{<-2.1,0,-.1><4.1,.5,4.1> texture{BrickText103}}
     object{Door1 rotate<0,90,0> translate<2,.5,0>}
     cylinder{<2,0,0><2,.25,0>,1.5 texture{pigment{color White}}}
     cylinder{<2,.25,0><2,.5,0>,1 texture{pigment{color White}}}

     object{Window1 rotate<0,90,0> translate<2,4,0>}
     object{Window1 rotate<0,90,0> translate<-2,.7,-4>}
     object{Window1 rotate<0,90,0> translate<-2,4,-4>}

     object{Window1 rotate<0,90,0> translate<2,.7,4>}
     object{Window1 rotate<0,90,0> translate<2,4,4>}
     object{Window1 rotate<0,90,0> translate<-2,.7,4>}
     object{Window1 rotate<0,90,0> translate<-2,4,4>}

     object{Window1 rotate<0,0,0> translate<-4,.7,2>}
     object{Window1 rotate<0,0,0> translate<-4,4,2>}
     object{Window1 rotate<0,0,0> translate<-4,.7,0>}
     object{Window1 rotate<0,0,0> translate<-4,4,0>}
     object{Window1 rotate<0,0,0> translate<-4,.7,-2>}
     object{Window1 rotate<0,0,0> translate<-4,4,-2>}

     triangle{<4.2,8,-.2><4.2,8,4.2><2,12,2> texture{RoofText101}}
     triangle{<4.2,8,-.2><2,12,2><-4.2,8,-.2> texture{RoofText101}}
     triangle{<-4.2,8,-.2><-2,12,2><2,12,2> texture{RoofText101}}
     triangle{<4.2,8,4.2><2,12,2><-4.2,8,4.2> texture{RoofText101}}
     triangle{<-4.2,8,4.2><-2,12,2><2,12,2> texture{RoofText101}}

//     triangle{<4.2,8,4.2><4.2,8,-.2><1,12,0> texture{RoofText101}}

     box{<-4,0,-4><0,8,4> texture{BrickText101}}
     box{<-4.2,7.8,-4.2><.20,8,4.2> texture{BrickText103}}
     box{<-4.1,0,-4.1><.1,.5,4.1> texture{BrickText103}}
     triangle{<-4.2,8,4.2><-4.2,8,-4.2><-2,12,2> texture{RoofText101}}
     triangle{<-4.2,8,-4.2><-2,12,-2><0,8,-4.2> texture{RoofText101}}
     triangle{<-4.2,8,-4.2><-2,12,2><-2,12,-2> texture{RoofText101}}
     triangle{<0,8,-4.2><-2,12,2><0,8,4.2> texture{RoofText101}}
     triangle{<0,8,-4.2><-2,12,2><-2,12,-2> texture{RoofText101}}

     box{<3,8,0><4,12,1> texture{BrickText103}}
     cylinder{<3.5,12,.5><3.5,16,.5>,.3 texture{BrickText102}}
     object{Door1 translate<-2,.2,0>}
     object{Door1 rotate<0,90,0> translate<-1,.2,0>}
}

#declare Build10=union{
     box{<-4,0,-4><4,5,4> texture{BrickText101}}
     box{<-4.1,5,-4.1><4.1,5.1,4.1> texture{BrickText103}}

     #declare Count=-3.2
     #while (Count<=3.2)
          object{Window1 rotate<0,90,0> translate<Count,2.,-4>}
          object{Window1 rotate<0,90,0> translate<Count,2.,4>}
          object{Window1 rotate<0,0,0> translate<-4,2.,Count>}
          object{Window1 rotate<0,0,0> translate<4,2.,Count>}
          #declare Count=Count+2.3
     #end
     object{Door1 rotate<0,90,0> translate<0,.2,-5>}

     box{<-2,0,-5><2,8,-1> texture{BrickText105}}
     triangle{<-2.2,8,-5.2><2.2,8,-5.2><0,16,-3> texture{RoofText101}}
     triangle{<-2.2,8,-.8><2.2,8,-.8><0,16,-3> texture{RoofText101}}
     triangle{<-2.2,8,-5.2><-2.2,8,-.8><0,16,-3> texture{RoofText101}}
     triangle{<2.2,8,-5.2><2.2,8,-.8><0,16,-3> texture{RoofText101}}
     object{Window1 translate<-2,5.5,-3>}
     object{Window1 translate<2,5.5,-3>}
     object{Window1 rotate<0,90,0> translate<-1,5.5,-5>}
     object{Window1 rotate<0,90,0> translate<1,5.5,-5>}
}

#declare Build11=union{
     box{<-5,0,-5><5,16,5> texture{BrickText106}}
     box{<-5.2,3,-5.2><5.2,3.2,5.2> texture{BrickText103}}
     box{<-5.2,6,-5.2><5.2,6.2,5.2> texture{BrickText103}}
     box{<-5.2,9,-5.2><5.2,9.2,5.2> texture{BrickText103}}
     box{<-5.2,12,-5.2><5.2,12.2,5.2> texture{BrickText103}}
     box{<-5.2,15,-5.2><5.2,15.2,5.2> texture{BrickText103}}
     box{<-5.2,15.5,-5.2><5.2,15.7,5.2> texture{BrickText103}}

     box{<-5.3,0,-2><5.3,15,2> texture{BrickText106}}
     object{Door1 rotate<0,0,0> translate<-5.3,.2,-.6>}
     object{Door1 rotate<0,0,0> translate<-5.3,.2,.6>}
     object{Door1 rotate<0,0,0> translate<5.3,.2,-.6>}
     object{Door1 rotate<0,0,0> translate<5.3,.2,.6>}

     #declare Count=.25
     #while (Count <=15.5)
           box{<-5.1,Count,-5.1><-4.7,Count+.25,-4.7> texture{pigment{color Gray}}}
           box{<-5.1,Count,5.1><-4.7,Count+.25,4.7> texture{pigment{color Gray}}}
           box{<5.1,Count,-5.1><4.7,Count+.25,-4.7> texture{pigment{color Gray}}}
           box{<5.1,Count,5.1><4.7,Count+.25,4.7> texture{pigment{color Gray}}}
          #declare Count=Count+.5
     #end

     #declare FL=3.5
     #while (FL<15)
        #declare Count=-3.5
        #while (Count<=3.5)
             #if (Count=0)
                #declare ADJ=.3
             #else
                #declare ADJ=0
             #end
             object{Window1 rotate<0,90,0> translate<Count,FL,-5>}
             object{Window1 rotate<0,90,0> translate<Count,FL,5>}
             object{Window1 rotate<0,0,0> translate<-5+ADJ,FL,Count>}
             object{Window1 rotate<0,0,0> translate<5+ADJ,FL,Count>}
             #declare Count=Count+3.5
        #end
        #declare FL=FL+3
     #end

     box{<-2,16,-2><-1,18,-1> texture{BrickText101}}                       // chimney
     cylinder{<-1.5,18,-1.5><-1.5,19,-1.5>,.25 texture{RoofText101}}
}

#declare Build12=union{
    box{<-4.5,0,-3><4.5,3,5> texture{BrickText101}}
    box{<-5.,3,-3.51><5.,6,5.51> texture{WoodSide101}}
    box{<-5.01,3,-3.5><5.01,6,5.5> texture{WoodSide101 rotate<0,90,0>}}
    box{<-5.2,5.8,-3.7><5.2,6,5.7> texture{T_Wood18}}  // trim
    box{<-5.1,3,-3.6><5.1,3.2,5.6> texture{T_Wood18}}  // trim

     #declare Count=-2.2
     #while (Count<=4.2)
          object{Window1 rotate<0,90,0> translate<Count,3.5,-3.5>}
          object{Window1 rotate<0,90,0> translate<Count,3.5,5.5>}
          object{Window1 rotate<0,0,0> translate<-5,3.5,Count>}
          object{Window1 rotate<0,0,0> translate<5,3.5,Count>}
          #declare Count=Count+2.3
     #end
     object{Door1 rotate<0,90,0> translate<0,.2,-3>}

    triangle{<-5.2,6,5.2><5.2,6,5.2><0,12,1> texture{RoofText101}}
    triangle{<-5.2,6,-3.7><5.2,6,-3.7><0,12,1> texture{RoofText101}}
    triangle{<-5.2,6,-3.7><-5.2,6,5.2><0,12,1> texture{RoofText101}}
    triangle{<5.2,6,-3.7><5.2,6,5.2><0,12,1> texture{RoofText101}}
}

#declare Build13a=union{
     cylinder{<0,0,0><0,10,0>,1 texture{BrickText106}}

     difference{
       cylinder{<0,10,0><0,13,0>,1.2 texture{BrickText106}}
       box{<-1.3,10.5,-.2><1.3,12,.2> texture{BrickText106}}
       cylinder{<-1.3,12,0><1.3,12,0>.2 texture{BrickText106}}
       box{<-.2,10.5,-1.3><.2,12,1.3> texture{BrickText106}}
       cylinder{<0,12,-1.3><0,12,1.3>.2 texture{BrickText106}}
     }

     cone{<0,13,0>1.4<0,16,0>,0 texture{RoofText101}}
     object{Window1 rotate<0,0,0> translate<-.975,.2,0> rotate<0,45,0>}
     object{Window1 rotate<0,0,0> translate<-.975,3.2,0> rotate<0,45,0>}
}
#declare Build13=union{
     box{<-3,0,-3><3,6,3> texture{BrickText106}}
     object{Door1 rotate<0,90,0> translate<0,.2,-3>}
     object{Window1 rotate<0,0,0> translate<-3,.2,0>}
     object{Window1 rotate<0,0,0> translate<3,.2,0>}
     object{Window1 rotate<0,0,0> translate<-3,3.2,0>}
     object{Window1 rotate<0,0,0> translate<3,3.2,0>}
     object{Window1 rotate<0,90,0> translate<0,3.2,-3>}

     object{Build13a rotate<0,-90,0> translate<-3,0,-3>}
     object{Build13a rotate<0,0,0> translate<-3,0,3>}
     object{Build13a rotate<0,180,0> translate<3,0,-3>}
     object{Build13a rotate<0,90,0> translate<3,0,3>}

     triangle{<-3.2,6,3.2><3.2,6,3.2><0,12,0> texture{RoofText101}}
     triangle{<-3.2,6,-3.2><3.2,6,-3.2><0,12,0> texture{RoofText101}}
     triangle{<-3.2,6,-3.2><-3.2,6,3.2><0,12,0> texture{RoofText101}}
     triangle{<3.2,6,-3.2><3.2,6,3.2><0,12,0> texture{RoofText101}}
}

#declare Build14=union{
   cylinder{<0,0,0><0,15,0>,4 texture{pigment{color Gray40}}}
   cylinder{<0,15,0><0,20,0>,4.4 texture{pigment{color Gray40}}}
   cone{<0,20,0>,4.6 <0,32,0>,0 texture{RoofText101}}
   #declare Count=0
   #while (Count<360)
      object{Window1 translate<4.4,16.5,0> rotate<0,Count,0>}
      #declare Count=Count+20
   #end
   object{Door1 translate<4,.2,0>}
}

#declare Build15=union{
   cylinder{<0,0,0><0,12,0>,5 texture{BrickText101}}
   cylinder{<0,12,0><0,16,0>,5.4 texture{BrickText101}}
   cone{<0,16,0>,5.6 <0,24,0>,0 texture{RoofText101}}
   cylinder{<0,24,0><0,30,0>,.1 texture{BrickText102}}
   #declare Count=0
   #while (Count<360)
      object{Window1 translate<5.4,13.5,0> rotate<0,Count,0>}
      #declare Count=Count+20
   #end
   object{Door1 translate<5,.2,0>}
}

#declare Build16=union{
   cylinder{<0,0,0><0,3,0>,3.2 texture{BrickText105}}
   cylinder{<0,0,0><0,12,0>,3 texture{BrickText105}}
   cylinder{<0,12,0><0,16,0>,3.4 texture{BrickText105}}
   cone{<0,16,0>,3.6 <0,24,0>,0 texture{RoofText101}}
   cylinder{<0,24,0><0,30,0>,.1 texture{BrickText102}}
   #declare Count=0
   #while (Count<360)
      object{Window1 translate<3.4,12.5,0> rotate<0,Count,0>}
      #declare Count=Count+20
   #end
   object{Door1 translate<3.2,.2,0>}
}

#declare Build17=difference{
  union{
    box{<-5,0,-5><5,3,-4.8> texture{BrickText105}}
    box{<-5,0,4.8><5,3,5> texture{BrickText105}}
    box{<-5,0,-5><-4.8,3,5> texture{BrickText105}}
    box{<4.8,0,-5><5,3,5> texture{BrickText105}}
    box{<-5.03,3,-5.03><5.03,3.2,-4.77> texture{BrickText101}}
    box{<-5.03,3,4.77><5.03,3.2,5.03> texture{BrickText101}}
    box{<-5.03,3,-5.03><-4.77,3.2,5.03> texture{BrickText101}}
    box{<4.77,3,-5.03><5.03,3.2,5.03> texture{BrickText101}}
    cylinder{<4.5,0,0><4.5,4,0>,1 texture{BrickText105}}
    cone{<4.5,4,0>,1.1<4.5,7,0>,0 texture{pigment{Tan}}}
  }
  box{<-5.511,-.10,-.5><5.511,2,.5> texture{BrickText105}}
  cylinder{<-5.511,2,0><5.511,2,0>,.5 texture{BrickText105}}
}

#declare Build18a=union{
    cylinder{<0,0,0><0,4,0>,1 texture{BrickText105}}
    cone{<0,4,0>,1.1<0,7,0>,0 texture{pigment{Tan}}}
}
#declare Build18=difference{
  union{
    box{<-5,0,-5><5,3,-4.8> texture{BrickText105}}
    box{<-5,0,4.8><5,3,5> texture{BrickText105}}
    box{<-5,0,-5><-4.8,3,5> texture{BrickText105}}
    box{<4.8,0,-5><5,3,5> texture{BrickText105}}
    box{<-5.03,3,-5.03><5.03,3.2,-4.77> texture{BrickText101}}
    box{<-5.03,3,4.77><5.03,3.2,5.03> texture{BrickText101}}
    box{<-5.03,3,-5.03><-4.77,3.2,5.03> texture{BrickText101}}
    box{<4.77,3,-5.03><5.03,3.2,5.03> texture{BrickText101}}
    object{Build18a translate<-5,0,-5>}
    object{Build18a translate<-5,0,5>}
    object{Build18a translate<5,0,-5>}
    object{Build18a translate<5,0,5>}
  }
  box{<-5.511,-.10,-.5><5.511,2,.5> texture{BrickText105}}
  cylinder{<-5.511,2,0><5.511,2,0>,.5 texture{BrickText105}}
}
